import fs = require("fs");
import path = require('path');

let mappings = [];

export class MainModule { 
   static path(options){
    let mainPath = `${options.homedir}/${options.uid}/main.${options.platform}.js`;
   
    if  (options.platform && fs.existsSync(mainPath)){
        return mainPath;
    }
    return `${options.homedir}/${options.uid}/main.js`;
   }

   static normalizedDepsPath(module, options){
        if (mappings[module]){
            return mappings[module];
        }

        const modulesPath = `${options.homedir}/${options.uid}/node_modules`
        const folderPath = `${options.homedir}/${options.uid}`;
                    
        if (module && module.charAt(0) === ".")
            mappings[module] = path.resolve(folderPath, module);
        else if (fs.existsSync(path.resolve(modulesPath, module)))
            mappings[module] = path.resolve(modulesPath, module);
        else
            mappings[module] = module;
            
        return mappings[module];
   }
}
